## mingw-w64-ghdl-5.1.1-2.src.tar.zst

=== testsuite/requirements.txt ===
-r ../pyGHDL/requirements.txt

# Test Runner
pytest ~= 8.4
pytest-cov ~= 6.2

# Coverage collection
Coverage ~= 7.9

=== src/psl/Makefile ===
#  Copyright (C) 2002 - 2015 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.

# Some files are automatically generated using pnodes.py
# This Makefile can be used to regenerate these files.  Generated files must
# be committed and distribued with the sources, so that users don't need to
# regenerate them (and don't need to have python installed).

PNODES=../../scripts/pnodes.py

DEPS=psl-nodes.ads psl-nodes.adb.in $(PNODES)

PNODES_FLAGS=--field-file=psl-nodes.adb.in \
  --kind-file=psl-nodes.ads \
  --node-file=psl-nodes.ads \
  --template-file=psl-nodes.adb.in \
  --meta-basename=psl-nodes_meta \
  --kind-type=Nkind \
  --kind-prefix=N_ \
  --node-type=Node

GEN_FILES=psl-nodes.adb psl-nodes_meta.ads psl-nodes_meta.adb

all: $(GEN_FILES)

psl-nodes.adb: psl-nodes.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(PNODES_FLAGS) body > $@
	chmod -w $@

psl-nodes_meta.ads: psl-nodes_meta.ads.in $(DEPS)
	$(RM) $@
	$(PNODES) $(PNODES_FLAGS) meta_specs > $@
	chmod -w $@

psl-nodes_meta.adb: psl-nodes_meta.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(PNODES_FLAGS) meta_body > $@
	chmod -w $@

clean:
	$(RM) -f $(GEN_FILES)

=== testsuite/vpi/vpi011/Makefile ===
SIM ?= ghdl
TOPLEVEL := dut
TOPLEVEL_LANG ?= vhdl
VHDL_SOURCES = dut.vhdl
MODULE = tb
include $(shell cocotb-config --makefiles)/Makefile.sim

=== PKGBUILD ===
_realname=ghdl
pkgbase="mingw-w64-${_realname}"
pkgname=(
  "${MINGW_PACKAGE_PREFIX}-${_realname}-llvm"
  "${MINGW_PACKAGE_PREFIX}-${_realname}-mcode"
)
pkgver=5.1.1
pkgrel=2
pkgdesc='GHDL: the open-source analyzer, compiler, simulator and (experimental) synthesizer for VHDL'
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url='https://github.com/ghdl/ghdl'
license=('spdx:GPL-2.0-or-later')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=(
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-ada"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-clang"
  "${MINGW_PACKAGE_PREFIX}-llvm"
  "${MINGW_PACKAGE_PREFIX}-autotools"
)
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-pytest")
options=(!emptydirs)
source=("https://github.com/ghdl/ghdl/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-support-llvm-21.patch::https://github.com/ghdl/ghdl/commit/560a822c.patch)
sha256sums=('00cd58ec8f25e2532465aabc8705f43071f20dc1d13e03fd9dc235523186fca9'
            '0228cc3694dc6438419073e94bdca7f4dc0334d23f2428e3aeb1171db1763ef5')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-support-llvm-21.patch
}

build() {
  echo "Building ghdl-llvm..."
  mkdir -p "${srcdir}"/build-${MSYSTEM}-llvm && cd "${srcdir}"/build-${MSYSTEM}-llvm

  CC=clang \
  CXX=clang++ \
  MSYS2_ARG_CONV_EXCL="--prefix" \
  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-checks \
    --enable-libghdl \
    --enable-synth \
    --with-llvm-config

  make GNATMAKE="gnatmake -j$(nproc)"

  echo "Building ghdl-mcode..."
  mkdir -p "${srcdir}"/build-${MSYSTEM}-mcode && cd "${srcdir}"/build-${MSYSTEM}-mcode

  MSYS2_ARG_CONV_EXCL="--prefix" \
  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-checks \
    --enable-libghdl \
    --enable-synth

  make GNATMAKE="gnatmake -j$(nproc)"
}

check() {
  cd "${srcdir}/build-${MSYSTEM}-llvm"
  make install.vpi.local
  make test
}

package_ghdl-llvm() {
  pkgdesc+=" (LLVM backend) (mingw-w64)"
  depends+=("${MINGW_PACKAGE_PREFIX}-llvm-libs")
  provides=("${MINGW_PACKAGE_PREFIX}-${_realname}")
  cd "${srcdir}"/build-${MSYSTEM}-llvm
  make DESTDIR="${pkgdir}" install

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/ghdl/grt.lst

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-llvm/licenses.rst
}

package_ghdl-mcode() {
  pkgdesc+=" (mcode backend) (mingw-w64)"
  depends+=("${MINGW_PACKAGE_PREFIX}-zlib")
  conflicts=("${MINGW_PACKAGE_PREFIX}-ghdl-llvm")
  cd "${srcdir}"/build-${MSYSTEM}-mcode
  make DESTDIR="${pkgdir}" install

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/lib/libghdl.link

  # License
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/doc/licenses.rst "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-mcode/licenses.rst
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
